import * as mc from "@minecraft/server";
mc.world.beforeEvents.worldInitialize.subscribe(event => {
	const itemComponentRegistry = event.itemComponentRegistry;
	const blockComponentRegistry = event.blockComponentRegistry;

	itemComponentRegistry.registerCustomComponent("ale:foice2",{onUse: arg => {foice2(arg.source);}});
});

mc.system.afterEvents.scriptEventReceive.subscribe(event => {
  const ale = event.id.split("ale:")[1];
  const eventEntity = event.sourceEntity;
  switch (ale) {
    case "dash":
      dash(eventEntity);
    break
  }
});

function dash(eventEntity) {
  eventEntity.applyKnockback(0,0,0,1);
  const entityRaycastHit = eventEntity.getEntitiesFromViewDirection({excludeFamilies:["inanimate","succubus"],excludeTypes:["item","xp_orb"]})[0];
  if(entityRaycastHit==undefined) return;
  const target = entityRaycastHit.entity;
  const targetLocation = target.location;
  const targetLocationX = targetLocation.x;
  const targetLocationY = targetLocation.y;
  const targetLocationZ = targetLocation.z;
  const eventEntityLocation = eventEntity.location;
  const eventEntityLocationX = eventEntityLocation.x;
  const eventEntityLocationY = eventEntityLocation.y;
  const eventEntityLocationZ = eventEntityLocation.z;
  const targetDistXZ = Math.sqrt(Math.pow((targetLocationX - eventEntityLocationX),2) + Math.pow((targetLocationZ - eventEntityLocationZ),2));
  const targetDistY = targetLocationY - eventEntityLocationY;
  const targetDist = Math.sqrt(Math.pow(targetDistXZ,2) + Math.pow(targetDistY,2));
  const viewDirection = eventEntity.getViewDirection();
  const horizontalStrength = targetDistXZ / (1 + targetDistXZ*0.02);
  const headRotation = eventEntity.getRotation().x;
  const verticalStrength = targetDistY/2;
  eventEntity.applyKnockback(viewDirection.x,viewDirection.z,horizontalStrength,0.8);
}

async function foice2(player) {
  player.runCommandAsync("playanimation @s animation.foice2 ale");
  player.runCommandAsync("playsound summon @a ~~~ 1.5");
  foice22(player, "ale:projetil_tamed2", [-3, 0, 0], "olhos1");
  foice22(player, "ale:projetil_tamed2", [3, 0, 0], "olhos2");
  foice22(player, "ale:projetil_tamed2", [0, 0, -3], "olhos3");
  foice22(player, "ale:projetil_tamed2", [0, 0, 3], "olhos4");
}

function foice22(player, powerId, offset, eventId) {
  const location = offsetL(player.getHeadLocation(),player.getRotation(),offset);
  common(location);
  function common(location) {
    const power = player.dimension.spawnEntity(powerId,location);
    if(eventId != null){
      power.triggerEvent(eventId);
    }
    const projectileComp = power.getComponent("projectile");
    projectileComp.owner = player;
    //projectileComp.shoot(player.getViewDirection());
  }
}

export function offsetL(location,rotation,offset){
  function round100000(number) {
      return Math.round(100000*number)/100000;
  }
  const x_entityRotationY = (rotation.y + 90) * (Math.PI/180);
  const x_positionX = -round100000(Math.sin(x_entityRotationY));
  const x_positionZ = round100000(Math.cos(x_entityRotationY));
  
  const z_entityRotationY = rotation.y * (Math.PI/180);
  const z_entityRotationX = rotation.x * (Math.PI/180);
  const z_positionX = -round100000(Math.sin(z_entityRotationY)*Math.cos(z_entityRotationX));
  const z_positionZ = round100000(Math.cos(z_entityRotationY)*Math.cos(z_entityRotationX));
  const z_positionY = -round100000(Math.sin(z_entityRotationX));
  
  const y_entityRotationY = rotation.y * (Math.PI/180);
  const y_entityRotationX = rotation.x * (Math.PI/180);
  const y_positionX = -round100000(Math.sin(y_entityRotationY)*Math.sin(y_entityRotationX));
  const y_positionZ = round100000(Math.cos(y_entityRotationY)*Math.sin(y_entityRotationX));
  const y_positionY = round100000(Math.cos(y_entityRotationX));

  return {
      x:location.x + x_positionX*offset[0] + y_positionX*offset[1] + z_positionX*offset[2],
      y:location.y + z_positionY*offset[2] + y_positionY*offset[1],
      z:location.z + x_positionZ*offset[0] + y_positionZ*offset[1] + z_positionZ*offset[2]
  }
}